# Hunter's Show Rates Addon
#  
# Install instructions:
#       1. Install Mattie's EventScripts 2.0 plugin:
#           http://mattie.info/cs/
#
#       2. Copy and upload this script to:
#           <gamedir>/addons/eventscripts/show_rates/
#
#       3. Add the following line somewhere in autoexec.cfg:
#           es_load show_rates
#
################################################################################
#import EventScripts
import es
#import Libraries
import popuplib
import playerlib
import gamethread
import usermsg
#import Psyco Compiler
import psyco
psyco.full()

# Addon Information
info = es.AddonInfo()
info.name = "Show Rates"
info.version = "2.0.0"
info.author = "Hunter"
info.url = "http://addons.eventscripts.com/addons/user/289"
info.description = "Allows players and admins to choose special skins"
info.basename = "show_rates"

hunter_show_rates_ver    = info.version
hunter_show_rates_text   = 'Hunters '+info.name+', www.sourceplugins.de, '+info.version+', ES 2.0.0.247+ (Python Version)'

# Server Variables
show_rates_rate          = es.ServerVar('show_rates_rate', '60', 'How often should the rates be queried? ( default = 60 | seconds )')
show_rates_announce      = es.ServerVar('show_rates_announce', '1', 'Show a message on query?')

# Global Variables
show_rates_variables     = file(es.getAddonPath('show_rates')+'/show_rates.txt').readlines()
show_rates_players       = {}
show_rates_popups        = {}

def load():
    public = es.ServerVar('hu_sr', info.version, info.name)
    public.makepublic()

    es.regsaycmd('!rates', 'show_rates/rates', 'Show Rates Info')
    es.log(hunter_show_rates_text)
    es.msg('#multi', '#green[ShowRates] #defaultLoaded')
    
def unload():
    for popup in show_rates_popups:
        show_rates_popups[popup].delete()

    gamethread.cancelDelayed('show_rates')

    es.unregsaycmd('!rates')
    es.msg('#multi', '#green[ShowRates] #defaultUnloaded') 

def es_map_start(event_var):
    global show_rates_players
    show_rates_players = {}
    for popup in show_rates_popups:
        show_rates_popups[popup].delete()

def es_client_command(event_var):
    if (str(event_var['command']) == '!hunter_show_rates_ver') or (str(event_var['command']) == '!hunter_all_ver'):
        es.cexec(int(event_var['userid']), 'echo '+hunter_show_rates_text)

def es_player_variable(event_var):
    if not int(event_var['userid']) in show_rates_players:
        show_rates_players[int(event_var['userid'])] = {}
    if int(event_var['userid']) in show_rates_players:
        show_rates_players[int(event_var['userid'])][str(event_var['variable'])] = {'value':str(event_var['value']), 'status':str(event_var['status'])}

def player_activate(event_var):
    gamethread.delayed(30, es.cexec, (int(event_var['userid']), 'echo '+hunter_show_rates_text))

def player_disconnect(event_var):
    if int(event_var['userid']) in show_rates_players:
        del show_rates_players[int(event_var['userid'])]

def round_start(event_var):
    gamethread.cancelDelayed('show_rates')
    gamethread.delayedname(3, 'show_rates', _check_rates)

def rates():
    show_rates_popups[0] = popuplib.construct('show_rates', 'players', '#human', _select_player)
    show_rates_popups[0].settitle('Show Rates\nSelect a player')
    show_rates_popups[0].vguititle = 'Show Rates - Select a player'
    show_rates_popups[0].send(es.getcmduserid())

def _select_player(userid, choice, popupid):
    if choice in show_rates_players:
        data = []
        for variable in show_rates_players[choice]:
            data.append('%s %s [%s]' % (variable, show_rates_players[choice][variable]['value'], show_rates_players[choice][variable]['status']))
        if popuplib.exists('show_rates_%s'%userid):
            popuplib.delete('show_rates_%s'%userid)
        show_rates_popups[userid] = popuplib.easylist('show_rates_%s'%userid, sorted(data))
        show_rates_popups[userid].settitle('Show Rates Player: %s' % es.getplayername(choice))
        show_rates_popups[userid].vguititle = 'Show Rates - Player: %s' % es.getplayername(choice)
        show_rates_popups[userid].submenu(10, 'show_rates')
        show_rates_popups[userid].send(userid)
    elif popuplib.exists(popupid):
        es.tell(userid, '#multi', '#green[ShowRates] #lightgreenSorry, no rates queried for that user yet!')
        popuplib.find(popupid).send(userid)

def _check_rates():
    if show_rates_variables and len(show_rates_variables):
        gamethread.delayedname(int(show_rates_rate), 'show_rates', _check_rates)
        for userid in playerlib.getUseridList('#human'):
            delay = 0
            if int(show_rates_announce):
                usermsg.hudhint(userid, 'Checking your variables...')
            for variable in show_rates_variables:
                gamethread.delayed(delay, es.queryclientvar, (userid, variable.strip()))
                delay += 1
